// ImageControl.cpp - implementation of image control
#include "StdAfx.h"
#include "TrackerWnd.h"

//---------------------------------------------------------------------
BOOL RegisterTrackerWndClass()
{
  WNDCLASS WndClass;
  WndClass.style = CS_DBLCLKS;
  WndClass.lpfnWndProc = DefWindowProc; 
  WndClass.cbClsExtra = 0;
  WndClass.cbWndExtra = 0;
  WndClass.hInstance = AfxGetInstanceHandle();
  WndClass.hIcon = NULL;
  WndClass.hCursor = LoadCursor( NULL, IDC_ARROW );
  WndClass.hbrBackground = (HBRUSH) GetStockObject( BLACK_BRUSH );
  WndClass.lpszMenuName = NULL;
  WndClass.lpszClassName = _T("TrackerWndClass");

  return (AfxRegisterClass( &WndClass ) != NULL);
};

//---------------------------------------------------------------------
CTrackerWnd::CTrackerWnd( CWnd* Parent, UINT nID )
{
    if (!SubclassDlgItem( nID, Parent )) VERIFY(FALSE); 
    RubberBand = FALSE;

    CRect R;
    GetClientRect(&R);

    R.InflateRect(CSize(-10,-10));
    Tracker.SetValidRect(R);    

    R.InflateRect(CSize(-30,-30));
    Tracker.SetPos(R.TopLeft(), R.BottomRight() );
    Tracker.SetLineWidth(2);
    Tracker.SetLineColor( RGB(0,255,0) ); // green
    Tracker.SetHandleSize(8);
    Tracker.SetHandleColor( RGB(255,255,0) ); // yellow

    
};

//---------------------------------------------------------------------
BEGIN_MESSAGE_MAP( CTrackerWnd, CWnd )
  	//{{AFX_MSG_MAP(CTrackerWnd)
    ON_WM_PAINT()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CTrackerWnd::OnPaint()
{
    CPaintDC dc(this);
    Tracker.Draw(&dc);
};

BOOL CTrackerWnd::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
    if (!RubberBand)
        if (Tracker.SetCursor(pWnd, nHitTest))
            return TRUE;
	
	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

void CTrackerWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CWnd ::OnLButtonDown(nFlags, point);

    if (RubberBand)
        Tracker.TrackRubberBand(this,point);
    else
        Tracker.Track(this,point);

    Invalidate();
    UpdateWindow();
}
